package ex.pt;

import blang.core.ConstantSupplier;
import blang.core.DeboxedName;
import blang.core.IntVar;
import blang.core.Model;
import blang.core.ModelBuilder;
import blang.core.ModelComponent;
import blang.core.Param;
import blang.core.RealVar;
import blang.inits.Arg;
import blang.inits.DesignatedConstructor;
import blang.types.StaticUtils;
import blang.types.internals.RealScalar;
import ca.ubc.stat.blang.StaticJavaUtils;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Optional;
import java.util.function.Supplier;

@SuppressWarnings("all")
public class UnidentifiableProduct implements Model {
  public static class Builder implements ModelBuilder {
    private boolean fromCommandLine = false;
    
    @Arg
    public Optional<RealVar> x;
    
    public UnidentifiableProduct.Builder setX(final RealVar x) {
      // work around typeRef(..) limitation
      Optional<RealVar> $generated__dummy = null;
      this.x = Optional.of(x);
      return this;
    }
    
    @Arg
    public Optional<RealVar> y;
    
    public UnidentifiableProduct.Builder setY(final RealVar y) {
      // work around typeRef(..) limitation
      Optional<RealVar> $generated__dummy = null;
      this.y = Optional.of(y);
      return this;
    }
    
    @Arg
    public Optional<IntVar> nTrials;
    
    public UnidentifiableProduct.Builder setNTrials(final IntVar nTrials) {
      // work around typeRef(..) limitation
      Optional<IntVar> $generated__dummy = null;
      this.nTrials = Optional.of(nTrials);
      return this;
    }
    
    @Arg
    public Optional<IntVar> nFails;
    
    public UnidentifiableProduct.Builder setNFails(final IntVar nFails) {
      // work around typeRef(..) limitation
      Optional<IntVar> $generated__dummy = null;
      this.nFails = Optional.of(nFails);
      return this;
    }
    
    public UnidentifiableProduct build() {
      // For each optional type, either get the value, or evaluate the ?: expression
      RealVar x;
      if (this.x != null && this.x.isPresent()) {
        x = this.x.get();
      } else {
        x = $generated__9();
      }
      final RealVar __x = x;
      RealVar y;
      if (this.y != null && this.y.isPresent()) {
        y = this.y.get();
      } else {
        y = $generated__10(x);
      }
      final RealVar __y = y;
      IntVar nTrials;
      if (this.nTrials != null && this.nTrials.isPresent()) {
        nTrials = this.nTrials.get();
      } else {
        nTrials = $generated__11(x, y);
      }
      final IntVar __nTrials = nTrials;
      IntVar nFails;
      if (this.nFails != null && this.nFails.isPresent()) {
        nFails = this.nFails.get();
      } else {
        nFails = $generated__12(x, y, nTrials);
      }
      final IntVar __nFails = nFails;
      // Build the instance after boxing params
      return new UnidentifiableProduct(
        __x, 
        __y, 
        __nFails, 
        new ConstantSupplier(__nTrials)
      );
    }
  }
  
  @DesignatedConstructor
  public static UnidentifiableProduct.Builder builderFromCommandLine() {
    Builder result = new Builder();
    result.fromCommandLine = true;
    return result;
  }
  
  private final RealVar x;
  
  public RealVar getX() {
    return x;
  }
  
  private final RealVar y;
  
  public RealVar getY() {
    return y;
  }
  
  @Param
  private final Supplier<IntVar> $generated__nTrials;
  
  public IntVar getNTrials() {
    return $generated__nTrials.get();
  }
  
  private final IntVar nFails;
  
  public IntVar getNFails() {
    return nFails;
  }
  
  /**
   * Utility main method for posterior inference on this model
   */
  public static void main(final String[] arguments) {
    StaticJavaUtils.callRunner(Builder.class, arguments);
  }
  
  /**
   * Auxiliary method generated to translate:
   * x
   */
  private static RealVar $generated__0(final RealVar x, final RealVar y, final IntVar nTrials, final IntVar nFails) {
    return x;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0.0
   */
  private static RealVar $generated__1() {
    return new blang.core.RealConstant(0.0);
  }
  
  public static class $generated__1_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__1();
    }
    
    public String toString() {
      return "0.0";
    }
    
    public $generated__1_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * 1.0
   */
  private static RealVar $generated__2() {
    return new blang.core.RealConstant(1.0);
  }
  
  public static class $generated__2_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__2();
    }
    
    public String toString() {
      return "1.0";
    }
    
    public $generated__2_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * y
   */
  private static RealVar $generated__3(final RealVar x, final RealVar y, final IntVar nTrials, final IntVar nFails) {
    return y;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0.0
   */
  private static RealVar $generated__4() {
    return new blang.core.RealConstant(0.0);
  }
  
  public static class $generated__4_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__4();
    }
    
    public String toString() {
      return "0.0";
    }
    
    public $generated__4_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * 1.0
   */
  private static RealVar $generated__5() {
    return new blang.core.RealConstant(1.0);
  }
  
  public static class $generated__5_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__5();
    }
    
    public String toString() {
      return "1.0";
    }
    
    public $generated__5_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * nFails
   */
  private static IntVar $generated__6(final RealVar x, final RealVar y, final IntVar nTrials, final IntVar nFails) {
    return nFails;
  }
  
  /**
   * Auxiliary method generated to translate:
   * nTrials
   */
  private static IntVar $generated__7(final IntVar nTrials, final RealVar x, final RealVar y) {
    return nTrials;
  }
  
  public static class $generated__7_class implements Supplier<IntVar> {
    public IntVar get() {
      return $generated__7($generated__nTrials.get(), x, y);
    }
    
    public String toString() {
      return "nTrials";
    }
    
    private final Supplier<IntVar> $generated__nTrials;
    
    private final RealVar x;
    
    private final RealVar y;
    
    public $generated__7_class(final Supplier<IntVar> $generated__nTrials, final RealVar x, final RealVar y) {
      this.$generated__nTrials = $generated__nTrials;
      this.x = x;
      this.y = y;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * x * y
   */
  private static RealVar $generated__8(final IntVar nTrials, final RealVar x, final RealVar y) {
    return new blang.core.RealConstant(((x).doubleValue() * (y).doubleValue()));
  }
  
  public static class $generated__8_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__8($generated__nTrials.get(), x, y);
    }
    
    public String toString() {
      return "x * y";
    }
    
    private final Supplier<IntVar> $generated__nTrials;
    
    private final RealVar x;
    
    private final RealVar y;
    
    public $generated__8_class(final Supplier<IntVar> $generated__nTrials, final RealVar x, final RealVar y) {
      this.$generated__nTrials = $generated__nTrials;
      this.x = x;
      this.y = y;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentReal
   */
  private static RealVar $generated__9() {
    RealScalar _latentReal = StaticUtils.latentReal();
    return _latentReal;
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentReal
   */
  private static RealVar $generated__10(final RealVar x) {
    RealScalar _latentReal = StaticUtils.latentReal();
    return _latentReal;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 100000
   */
  private static IntVar $generated__11(final RealVar x, final RealVar y) {
    return new blang.core.IntConstant(100000);
  }
  
  /**
   * Auxiliary method generated to translate:
   * nTrials/2
   */
  private static IntVar $generated__12(final RealVar x, final RealVar y, final IntVar nTrials) {
    return new blang.core.IntConstant(((nTrials).intValue() / 2));
  }
  
  /**
   * Note: the generated code has the following properties used at runtime:
   *   - all arguments are annotated with a BlangVariable annotation
   *   - params additionally have a Param annotation
   *   - the order of the arguments is as follows:
   *     - first, all the random variables in the order they occur in the blang file
   *     - second, all the params in the order they occur in the blang file
   * 
   */
  public UnidentifiableProduct(@DeboxedName("x") final RealVar x, @DeboxedName("y") final RealVar y, @DeboxedName("nFails") final IntVar nFails, @Param @DeboxedName("nTrials") final Supplier<IntVar> $generated__nTrials) {
    this.x = x;
    this.y = y;
    this.$generated__nTrials = $generated__nTrials;
    this.nFails = nFails;
  }
  
  /**
   * A component can be either a distribution, support constraint, or another model  
   * which recursively defines additional components.
   */
  public Collection<ModelComponent> components() {
    ArrayList<ModelComponent> components = new ArrayList();
    
    { // Code generated by: x ~ ContinuousUniform(0.0, 1.0)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.ContinuousUniform(
          $generated__0(x, y, $generated__nTrials.get(), nFails), 
          new $generated__1_class(), 
          new $generated__2_class()
        )
        );
    }
    { // Code generated by: y ~ ContinuousUniform(0.0, 1.0)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.ContinuousUniform(
          $generated__3(x, y, $generated__nTrials.get(), nFails), 
          new $generated__4_class(), 
          new $generated__5_class()
        )
        );
    }
    { // Code generated by: nFails | nTrials, x, y ~ Binomial(nTrials, x * y)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Binomial(
          $generated__6(x, y, $generated__nTrials.get(), nFails), 
          new $generated__7_class($generated__nTrials, x, y), 
          new $generated__8_class($generated__nTrials, x, y)
        )
        );
    }
    
    return components;
  }
}
