require("ggplot2")
require("dplyr")

data <- read.csv("/Users/bouchard/w/blogobayes/www/ex/pt/results/all/UnidentifiableProduct-1896176519/samples/nOutOfSupport.csv")

# ggplot has bad default sizes for large facetting
verticalSize <- 2.0 *  length(unique(data$chain)) 
horizontalSize <- 4.0


p <- ggplot(data, aes(x = sample, y = value)) +
  geom_step() + facet_grid(chain ~ .
  , scales="free") + 
  theme_bw() + 
  xlab("MCMC iteration") +
  ylab("sample") +
  ggtitle("Trace plot for: nOutOfSupport")
ggsave("/Users/bouchard/w/blogobayes/www/ex/pt/results/all/UnidentifiableProduct-1896176519/tracePlotsFull/nOutOfSupport.pdf", limitsize = F, height = verticalSize, width = horizontalSize)
